﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Web.Mvc;
using OPS_AdvancedExample_ASP.Models;

namespace OPS_AdvancedExample_ASP.Controllers
{
    public class LogCallsController : Controller
    {
        public ActionResult Index()
        {
            return View(GetModelFromFile("c:\\LoggedCalls.txt"));
        }

        [HttpPost]
        public void LogCall(string notificationName, string callState, string callId, string caller, string callerId, string callee)
        {
            WriteToFile("c:\\LoggedCalls.txt",
                        notificationName + ";" + callState + ";" +
                        callId + ";" + caller + ";" + callerId + ";" +
                        callee + ";" + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "\n");
        }

        /// <summary>
        /// Make a LoggedCall list from the splitted file content
        /// </summary>
        /// <param name="filepath"></param>
        /// <returns></returns>
        private List<LoggedCall> GetModelFromFile(string filepath)
        {
            var loggedCalls = new List<LoggedCall>();
            var content = ReadFromFile(filepath);

            var splittedContent = content.Split(new[] { ';', '\n' }, StringSplitOptions.RemoveEmptyEntries);

            try
            {
                for (int i = 0; i < splittedContent.Length; i += 7)
                    loggedCalls.Add(new LoggedCall(splittedContent[i], splittedContent[i + 1], splittedContent[i + 2],
                                                   splittedContent[i + 3], splittedContent[i + 4],
                                                   splittedContent[i + 5], splittedContent[i + 6]));

            }
            catch (Exception)
            {
                Console.WriteLine("Error during making splitted list");
            }

            return loggedCalls;
        }

        private string ReadFromFile(string filepath)
        {
            var content = string.Empty;

            if (!System.IO.File.Exists(filepath))
                return content;

            try
            {
                using (var sr = new StreamReader(filepath))
                {
                    content = sr.ReadToEnd();
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("The file " + filepath + "could not be read:");
                Console.WriteLine(e.Message);
            }

            return content;
        }

        private void WriteToFile(string filepath, string content)
        {
            using (var fs = new FileStream(filepath, FileMode.Append, FileAccess.Write, FileShare.Read))
            {
                using (var writer = new StreamWriter(fs))
                {
                    writer.Write(content);

                    writer.Flush();
                    writer.Close();
                }
                fs.Close();
            }
        }
    }
}
