﻿using System;
using System.Collections.Generic;
using System.Web.Mvc;
using OPS_AdvancedExample_ASP.Models;
using WebMatrix.Data;

namespace OPS_AdvancedExample_ASP.Controllers
{
    public class RecordCallsController : Controller
    {
        public ActionResult Index()
        {
            return View(GetRecordedCalls());
        }

        private List<RecordedCall> GetRecordedCalls()
        {
            var recordedCalls = new List<RecordedCall>();

            try
            {
                var db = Database.Open("CallDB");

                foreach (var row in db.Query("SELECT * FROM RecordedCalls"))
                    recordedCalls.Add(new RecordedCall(row.Success, row.Duration, row.RecordURL, row.CallId, row.Caller, row.Callee, row.NotificationName, row.Date));

                db.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }

            return recordedCalls;
        }

        [HttpPost]
        public ActionResult RecordCall(string notificationName, string callState, string callId, string caller, string callerId, string callee)
        {
            if (callState != "InCall")
                return Content("");

            return Content(
                "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" +
                "<Response>" +
                "<Record finishedUrl=\"http://localhost:7890/RecordCalls/CallRecorded\" format=\"mp3\"/>" +
                "</Response>", "text/xml");

        }

        [HttpPost]
        public void CallRecorded(string success, string duration, string recordUrl, string callID, string caller, string callee, string notificationName)
        {
            try
            {
                var db = Database.Open("CallDB");
                var insertQueryString = "INSERT INTO RecordedCalls " +
                                        "(Success, Duration, RecordUrl, CallID, Caller, Callee, NotificationName, Date) " +
                                        "VALUES ('" + success + "', '" + duration + "', '" + recordUrl + "', '" + callID + "', '" + caller + "', '" + callee + "', '" + notificationName + "', '" + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "')";

                db.Query(insertQueryString);
                db.Close();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }
    }
}
