﻿namespace OPS_AdvancedExample_ASP.Models
{
    public class RecordedCall
    {
        public string Success { get; private set; }
        public string Duration { get; private set; }
        public string RecordURL { get; private set; }
        public string CallId { get; private set; }
        public string Caller { get; private set; }
        public string Callee { get; private set; }
        public string NotificationName { get; private set; }
        public string Date { get; private set; }

        /// <param name="success">Set true if recording was successful. It is false if the call party voice cannot be detected or hung up before anything could be recorded</param>
        /// <param name="duration">If recording was success, the record duration is larger than 0, expressed in seconds</param>
        /// <param name="recordURL">URL of the recorded file. It is empty if recording was not successfull</param>
        /// <param name="callId">Call ID of the call that was recorded</param>
        /// <param name="caller">Caller extension party of the recorded conversation</param>
        /// <param name="callee">Callee extension party of the recorded conversation</param>
        /// <param name="notificationName">Name of the notification request type</param>
        /// <param name="date">Date of the record completed</param>
        public RecordedCall(string success, string duration, string recordURL, string callId, string caller, string callee, string notificationName, string date)
        {
            Success = success;
            Duration = duration;
            RecordURL = recordURL;
            CallId = callId;
            Caller = caller;
            Callee = callee;
            NotificationName = notificationName;
            Date = date;
        }
    }
}